
#ifndef _TM_FUNCS_H
#define _TM_FUNCS_H

#include "tm.h"

/* Widget creation functions */
extern int Tm_AnyCmd _ANSI_ARGS_((ClientData clientData, Tcl_Interp *interp,
            int argc, char **argv));
extern int Tm_ScrolledCmd _ANSI_ARGS_((ClientData clientData, Tcl_Interp *interp,
            int argc, char **argv));
extern int Tm_DialogCmd _ANSI_ARGS_((ClientData clientData, Tcl_Interp *interp,
            int argc, char **argv));
extern int Tm_ArrowButtonCmd _ANSI_ARGS_((ClientData clientData, Tcl_Interp *interp,
            int argc, char **argv));
extern int Tm_BulletinBoardCmd _ANSI_ARGS_((ClientData clientData, Tcl_Interp *interp,
            int argc, char **argv));
extern int Tm_CascadeButtonCmd _ANSI_ARGS_((ClientData clientData, Tcl_Interp *interp,
            int argc, char **argv));
extern int Tm_CommandCmd _ANSI_ARGS_((ClientData clientData, Tcl_Interp *interp,
            int argc, char **argv));
extern int Tm_DrawingAreaCmd _ANSI_ARGS_((ClientData clientData, Tcl_Interp *interp,
            int argc, char **argv));
extern int Tm_DrawnButtonCmd _ANSI_ARGS_((ClientData clientData, Tcl_Interp *interp,
            int argc, char **argv));
extern int Tm_FileSelectionCmd _ANSI_ARGS_((ClientData clientData, Tcl_Interp *interp,
            int argc, char **argv));
extern int Tm_FormCmd _ANSI_ARGS_((ClientData clientData, Tcl_Interp *interp,
            int argc, char **argv));
extern int Tm_FrameCmd _ANSI_ARGS_((ClientData clientData, Tcl_Interp *interp,
            int argc, char **argv));
extern int Tm_LabelCmd _ANSI_ARGS_((ClientData clientData, Tcl_Interp *interp,
            int argc, char **argv));
extern int Tm_ListCmd _ANSI_ARGS_((ClientData clientData, Tcl_Interp *interp,
            int argc, char **argv));
extern int Tm_MainWindowCmd _ANSI_ARGS_((ClientData clientData, Tcl_Interp *interp,
            int argc, char **argv));
extern int Tm_MessageBoxCmd _ANSI_ARGS_((ClientData clientData, Tcl_Interp *interp,
            int argc, char **argv));
extern int Tm_PanedWindowCmd _ANSI_ARGS_((ClientData clientData, Tcl_Interp *interp,
            int argc, char **argv));
extern int Tm_PushButtonCmd _ANSI_ARGS_((ClientData clientData, Tcl_Interp *interp,
            int argc, char **argv));
extern int Tm_RowColumnCmd _ANSI_ARGS_((ClientData clientData, Tcl_Interp *interp,
            int argc, char **argv));
extern int Tm_ScaleCmd _ANSI_ARGS_((ClientData clientData, Tcl_Interp *interp,
            int argc, char **argv));
extern int Tm_ScrollBarCmd _ANSI_ARGS_((ClientData clientData, Tcl_Interp *interp,
            int argc, char **argv));
extern int Tm_ScrolledListCmd _ANSI_ARGS_((ClientData clientData, Tcl_Interp *interp,
            int argc, char **argv));
extern int Tm_ScrolledTextCmd _ANSI_ARGS_((ClientData clientData, Tcl_Interp *interp,
            int argc, char **argv));
extern int Tm_SelectionBoxCmd _ANSI_ARGS_((ClientData clientData, Tcl_Interp *interp,
            int argc, char **argv));
extern int Tm_SeparatorCmd _ANSI_ARGS_((ClientData clientData, Tcl_Interp *interp,
            int argc, char **argv));
extern int Tm_TextCmd _ANSI_ARGS_((ClientData clientData, Tcl_Interp *interp,
            int argc, char **argv));
extern int Tm_TextFieldCmd _ANSI_ARGS_((ClientData clientData, Tcl_Interp *interp,
            int argc, char **argv));
extern int Tm_ToggleButtonCmd _ANSI_ARGS_((ClientData clientData, Tcl_Interp *interp,
            int argc, char **argv));

/* wdiget specific commands */
extern int Tm_AnyWidgetCmd _ANSI_ARGS_((ClientData clientData, Tcl_Interp *interp,
	     int argc, char **argv));
extern int Tm_ListWidgetCmd _ANSI_ARGS_((ClientData clientData, Tcl_Interp *interp,
	     int argc, char **argv));
extern int Tm_TextWidgetCmd _ANSI_ARGS_((ClientData clientData, Tcl_Interp *interp,
	     int argc, char **argv));

/* other funcs */
extern void Tm_LoadWidgetCommands _ANSI_ARGS_((Tcl_Interp *interp));
extern Tm_Widget *Tm_WidgetInfoFromPath _ANSI_ARGS_((Tcl_Interp *interp,
	     char *path));
extern Widget Tm_ParentWidgetFromPath _ANSI_ARGS_((Tcl_Interp *interp,
	     char *path));
extern char *Tm_HiddenParentPath _ANSI_ARGS_((char *path));
extern char *Tm_ParentPath _ANSI_ARGS_((char *path));
extern void Tm_StoreWidgetInfo _ANSI_ARGS_((char *path, Tm_Widget *w,
	     Tcl_Interp *interp));
extern void Tm_SetValues _ANSI_ARGS_((char *pathName, Tcl_Interp *interp,	
	     Widget w, Widget parent, WidgetClass class, char **argv, int argc,
	     Arg args[], int *num_args));
extern void Tm_GetSecondaryResources _ANSI_ARGS_((WidgetClass class,
	     XmSecondaryResourceData **resources, Cardinal *num_resources));
extern void Tm_GetExtensionResources _ANSI_ARGS_((WidgetClass class,
	     XtResourceList *resources, Cardinal *num_resources));
extern char *Tm_ExpandPercents _ANSI_ARGS_((Tm_Widget *widget_info, XtPointer call_data, 
	     char *before));
extern char *Tm_NameFromPath _ANSI_ARGS_((char *pathName));
extern void Tm_WidgetCallbackHandler _ANSI_ARGS_((Widget w, 
	     XtPointer client_data, XtPointer call_data));
extern void Tm_DestroyWidgetHandler _ANSI_ARGS_((Widget w, 
	     XtPointer client_data, XtPointer call_data));
extern void Tm_TextVerifyCallbackHandler _ANSI_ARGS_((Widget w, 
	     XtPointer client_data, XtPointer call_data));


/* Converter functions */
extern Boolean Tm_CvtStringToWidget _ANSI_ARGS_((Display *display,
	      XrmValuePtr args, Cardinal *num_args,
	      XrmValuePtr fromVal, XrmValuePtr toVal,
	      XtPointer* destructor_data));
extern Boolean Tm_CvtXmStringToString _ANSI_ARGS_((Display *display,
	      XrmValuePtr args, Cardinal *num_args,
	      XrmValuePtr fromVal, XrmValuePtr toVal,
	      XtPointer* destructor_data));
extern void Tm_RegisterConverters _ANSI_ARGS_((Tcl_Interp *interp,
	      XtAppContext appContext));
    XtAppContext appContext;


#endif /* _TM_FUNCS_H */
